diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/theme.php ./wordpress-3.4/wp-includes/theme.php
*** ./wordpress-3.3.2/wp-includes/theme.php	2011-11-14 17:56:18.000000000 -0600
--- ./wordpress-3.4/wp-includes/theme.php	2012-06-12 10:57:11.000000000 -0500
***************
*** 1431,1446 ****
  }
  
  /**
   * Retrieve header image for custom header.
   *
   * @since 2.1.0
-  * @uses HEADER_IMAGE
   *
   * @return string
   */
  function get_header_image() {
! 	$default = defined( 'HEADER_IMAGE' ) ? HEADER_IMAGE : '';
! 	$url = get_theme_mod( 'header_image', $default );
  
  	if ( 'remove-header' == $url )
  		return false;
--- 839,867 ----
  }
  
  /**
+  * Whether to display the header text.
+  *
+  * @since 3.4.0
+  *
+  * @return bool
+  */
+ function display_header_text() {
+ 	if ( ! current_theme_supports( 'custom-header', 'header-text' ) )
+ 		return false;
+ 
+ 	$text_color = get_theme_mod( 'header_textcolor', get_theme_support( 'custom-header', 'default-text-color' ) );
+ 	return 'blank' != $text_color;
+ }
+ 
+ /**
   * Retrieve header image for custom header.
   *
   * @since 2.1.0
   *
   * @return string
   */
  function get_header_image() {
! 	$url = get_theme_mod( 'header_image', get_theme_support( 'custom-header', 'default-image' ) );
  
  	if ( 'remove-header' == $url )
  		return false;
***************
*** 1457,1493 ****
  }
  
  /**
!  * Get random header image from registered images in theme.
   *
!  * @since 3.2.0
   *
   * @return string Path to header image
   */
- function get_random_header_image() {
- 	global $_wp_default_headers;
  
! 	$header_image_mod = get_theme_mod( 'header_image', '' );
! 	$headers = array();
  
! 	if ( 'random-uploaded-image' == $header_image_mod )
! 		$headers = get_uploaded_header_images();
! 	elseif ( ! empty( $_wp_default_headers ) ) {
! 		if ( 'random-default-image' == $header_image_mod ) {
! 			$headers = $_wp_default_headers;
! 		} else {
! 			$is_random = get_theme_support( 'custom-header' );
! 			if ( isset( $is_random[ 0 ] ) && !empty( $is_random[ 0 ][ 'random-default' ] ) )
  				$headers = $_wp_default_headers;
  		}
- 	}
  
! 	if ( empty( $headers ) )
! 		return '';
  
! 	$random_image = array_rand( $headers );
! 	$header_url = sprintf( $headers[$random_image]['url'], get_template_directory_uri(), get_stylesheet_directory_uri() );
  
! 	return $header_url;
  }
  
  /**
--- 878,935 ----
  }
  
  /**
!  * Get random header image data from registered images in theme.
   *
!  * @since 3.4.0
!  *
!  * @access private
   *
   * @return string Path to header image
   */
  
! function _get_random_header_data() {
! 	static $_wp_random_header;
  
! 	if ( empty( $_wp_random_header ) ) {
! 		global $_wp_default_headers;
! 		$header_image_mod = get_theme_mod( 'header_image', '' );
! 		$headers = array();
! 
! 		if ( 'random-uploaded-image' == $header_image_mod )
! 			$headers = get_uploaded_header_images();
! 		elseif ( ! empty( $_wp_default_headers ) ) {
! 			if ( 'random-default-image' == $header_image_mod ) {
  				$headers = $_wp_default_headers;
+ 			} else {
+ 				if ( current_theme_supports( 'custom-header', 'random-default' ) )
+ 					$headers = $_wp_default_headers;
+ 			}
  		}
  
! 		if ( empty( $headers ) )
! 			return new stdClass;
  
! 		$_wp_random_header = (object) $headers[ array_rand( $headers ) ];
  
! 		$_wp_random_header->url =  sprintf( $_wp_random_header->url, get_template_directory_uri(), get_stylesheet_directory_uri() );
! 		$_wp_random_header->thumbnail_url =  sprintf( $_wp_random_header->thumbnail_url, get_template_directory_uri(), get_stylesheet_directory_uri() );
! 	}
! 	return $_wp_random_header;
! }
! 
! /**
!  * Get random header image url from registered images in theme.
!  *
!  * @since 3.2.0
!  *
!  * @return string Path to header image
!  */
! 
! function get_random_header_image() {
! 	$random_image = _get_random_header_data();
! 	if ( empty( $random_image->url ) )
! 		return '';
! 	return $random_image->url;
  }
  
  /**
***************
*** 1498,1511 ****
   * is chosen, and theme turns on random headers with add_theme_support().
   *
   * @since 3.2.0
-  * @uses HEADER_IMAGE
   *
   * @param string $type The random pool to use. any|default|uploaded
   * @return boolean
   */
  function is_random_header_image( $type = 'any' ) {
! 	$default = defined( 'HEADER_IMAGE' ) ? HEADER_IMAGE : '';
! 	$header_image_mod = get_theme_mod( 'header_image', $default );
  
  	if ( 'any' == $type ) {
  		if ( 'random-default-image' == $header_image_mod || 'random-uploaded-image' == $header_image_mod || ( '' != get_random_header_image() && empty( $header_image_mod ) ) )
--- 940,951 ----
   * is chosen, and theme turns on random headers with add_theme_support().
   *
   * @since 3.2.0
   *
   * @param string $type The random pool to use. any|default|uploaded
   * @return boolean
   */
  function is_random_header_image( $type = 'any' ) {
! 	$header_image_mod = get_theme_mod( 'header_image', get_theme_support( 'custom-header', 'default-image' ) );
  
  	if ( 'any' == $type ) {
  		if ( 'random-default-image' == $header_image_mod || 'random-uploaded-image' == $header_image_mod || ( '' != get_random_header_image() && empty( $header_image_mod ) ) )
***************
*** 1547,1621 ****
  
  	foreach ( (array) $headers as $header ) {
  		$url = esc_url_raw( $header->guid );
! 		$header = basename($url);
! 		$header_images[$header] = array();
! 		$header_images[$header]['url'] =  $url;
! 		$header_images[$header]['thumbnail_url'] =  $url;
! 		$header_images[$header]['uploaded'] = true;
  	}
  
  	return $header_images;
  }
  
  /**
!  * Add callbacks for image header display.
!  *
!  * The parameter $header_callback callback will be required to display the
!  * content for the 'wp_head' action. The parameter $admin_header_callback
!  * callback will be added to Custom_Image_Header class and that will be added
!  * to the 'admin_menu' action.
!  *
!  * @since 2.1.0
!  * @uses Custom_Image_Header Sets up for $admin_header_callback for administration panel display.
!  *
!  * @param callback $header_callback Call on 'wp_head' action.
!  * @param callback $admin_header_callback Call on custom header administration screen.
!  * @param callback $admin_image_div_callback Output a custom header image div on the custom header administration screen. Optional.
!  */
! function add_custom_image_header( $header_callback, $admin_header_callback, $admin_image_div_callback = '' ) {
! 	if ( ! empty( $header_callback ) )
! 		add_action('wp_head', $header_callback);
! 
! 	$support = array( 'callback' => $header_callback );
! 	$theme_support = get_theme_support( 'custom-header' );
! 	if ( ! empty( $theme_support ) && is_array( $theme_support[ 0 ] ) )
! 		$support = array_merge( $theme_support[ 0 ], $support );
! 	add_theme_support( 'custom-header',  $support );
! 	add_theme_support( 'custom-header-uploads' );
! 
! 	if ( ! is_admin() )
! 		return;
! 
! 	global $custom_image_header;
! 
! 	require_once( ABSPATH . 'wp-admin/custom-header.php' );
! 	$custom_image_header = new Custom_Image_Header( $admin_header_callback, $admin_image_div_callback );
! 	add_action( 'admin_menu', array( &$custom_image_header, 'init' ) );
! }
! 
! /**
!  * Remove image header support.
   *
!  * @since 3.1.0
!  * @see add_custom_image_header()
   *
!  * @return bool Whether support was removed.
   */
! function remove_custom_image_header() {
! 	if ( ! current_theme_supports( 'custom-header' ) )
! 		return false;
! 
! 	$callback = get_theme_support( 'custom-header' );
! 	remove_action( 'wp_head', $callback[0]['callback'] );
! 	_remove_theme_support( 'custom-header' );
! 	remove_theme_support( 'custom-header-uploads' );
! 
! 	if ( is_admin() ) {
! 		remove_action( 'admin_menu', array( &$GLOBALS['custom_image_header'], 'init' ) );
! 		unset( $GLOBALS['custom_image_header'] );
! 	}
! 
! 	return true;
  }
  
  /**
--- 987,1021 ----
  
  	foreach ( (array) $headers as $header ) {
  		$url = esc_url_raw( $header->guid );
! 		$header_data = wp_get_attachment_metadata( $header->ID );
! 		$header_index = basename($url);
! 		$header_images[$header_index] = array();
! 		$header_images[$header_index]['attachment_id'] =  $header->ID;
! 		$header_images[$header_index]['url'] =  $url;
! 		$header_images[$header_index]['thumbnail_url'] =  $url;
! 		$header_images[$header_index]['width'] = $header_data['width'];
! 		$header_images[$header_index]['height'] = $header_data['height'];
  	}
  
  	return $header_images;
  }
  
  /**
!  * Get the header image data.
   *
!  * @since 3.4.0
   *
!  * @return object
   */
! function get_custom_header() {
! 	$data = is_random_header_image()? _get_random_header_data() : get_theme_mod( 'header_image_data' );
! 	$default = array(
! 		'url'           => '',
! 		'thumbnail_url' => '',
! 		'width'         => get_theme_support( 'custom-header', 'width' ),
! 		'height'        => get_theme_support( 'custom-header', 'height' ),
! 	);
! 	return (object) wp_parse_args( $data, $default );
  }
  
  /**
***************
*** 1663,1671 ****
   * @return string
   */
  function get_background_image() {
! 	$default = defined('BACKGROUND_IMAGE') ? BACKGROUND_IMAGE : '';
! 
! 	return get_theme_mod('background_image', $default);
  }
  
  /**
--- 1063,1069 ----
   * @return string
   */
  function get_background_image() {
! 	return get_theme_mod('background_image', get_theme_support( 'custom-background', 'default-image' ) );
  }
  
  /**
***************
*** 1681,1694 ****
   * Retrieve value for custom background color.
   *
   * @since 3.0.0
-  * @uses BACKGROUND_COLOR
   *
   * @return string
   */
  function get_background_color() {
! 	$default = defined('BACKGROUND_COLOR') ? BACKGROUND_COLOR : '';
! 
! 	return get_theme_mod('background_color', $default);
  }
  
  /**
--- 1079,1089 ----
   * Retrieve value for custom background color.
   *
   * @since 3.0.0
   *
   * @return string
   */
  function get_background_color() {
! 	return get_theme_mod('background_color', get_theme_support( 'custom-background', 'default-color' ) );
  }
  
  /**
***************
*** 1701,1772 ****
  }
  
  /**
-  * Add callbacks for background image display.
-  *
-  * The parameter $header_callback callback will be required to display the
-  * content for the 'wp_head' action. The parameter $admin_header_callback
-  * callback will be added to Custom_Background class and that will be added
-  * to the 'admin_menu' action.
-  *
-  * @since 3.0.0
-  * @uses Custom_Background Sets up for $admin_header_callback for administration panel display.
-  *
-  * @param callback $header_callback Call on 'wp_head' action.
-  * @param callback $admin_header_callback Call on custom background administration screen.
-  * @param callback $admin_image_div_callback Output a custom background image div on the custom background administration screen. Optional.
-  */
- function add_custom_background( $header_callback = '', $admin_header_callback = '', $admin_image_div_callback = '' ) {
- 	if ( isset( $GLOBALS['custom_background'] ) )
- 		return;
- 
- 	if ( empty( $header_callback ) )
- 		$header_callback = '_custom_background_cb';
- 
- 	add_action( 'wp_head', $header_callback );
- 
- 	add_theme_support( 'custom-background', array( 'callback' => $header_callback ) );
- 
- 	if ( ! is_admin() )
- 		return;
- 	require_once( ABSPATH . 'wp-admin/custom-background.php' );
- 	$GLOBALS['custom_background'] = new Custom_Background( $admin_header_callback, $admin_image_div_callback );
- 	add_action( 'admin_menu', array( &$GLOBALS['custom_background'], 'init' ) );
- }
- 
- /**
-  * Remove custom background support.
-  *
-  * @since 3.1.0
-  * @see add_custom_background()
-  *
-  * @return bool Whether support was removed.
-  */
- function remove_custom_background() {
- 	if ( ! current_theme_supports( 'custom-background' ) )
- 		return false;
- 
- 	$callback = get_theme_support( 'custom-background' );
- 	remove_action( 'wp_head', $callback[0]['callback'] );
- 	_remove_theme_support( 'custom-background' );
- 
- 	if ( is_admin() ) {
- 		remove_action( 'admin_menu', array( &$GLOBALS['custom_background'], 'init' ) );
- 		unset( $GLOBALS['custom_background'] );
- 	}
- 
- 	return true;
- }
- 
- /**
   * Default custom background callback.
   *
   * @since 3.0.0
-  * @see add_custom_background()
   * @access protected
   */
  function _custom_background_cb() {
  	$background = get_background_image();
! 	$color = get_background_color();
  	if ( ! $background && ! $color )
  		return;
  
--- 1096,1114 ----
  }
  
  /**
   * Default custom background callback.
   *
   * @since 3.0.0
   * @access protected
   */
  function _custom_background_cb() {
+ 	// $background is the saved custom image, or the default image.
  	$background = get_background_image();
! 
! 	// $color is the saved custom color.
! 	// A default has to be specified in style.css. It will not be printed here.
! 	$color = get_theme_mod( 'background_color' );
! 
  	if ( ! $background && ! $color )
  		return;
  
***************
*** 1793,1799 ****
  		$style .= $image . $repeat . $position . $attachment;
  	}
  ?>
! <style type="text/css">
  body.custom-background { <?php echo trim( $style ); ?> }
  </style>
  <?php
--- 1135,1141 ----
  		$style .= $image . $repeat . $position . $attachment;
  	}
  ?>
! <style type="text/css" id="custom-background-css">
  body.custom-background { <?php echo trim( $style ); ?> }
  </style>
  <?php
***************
*** 1806,1815 ****
   * the theme root. It also accepts an array of stylesheets.
   * It is optional and defaults to 'editor-style.css'.
   *
!  * Supports RTL stylesheets automatically by searching for the -rtl prefix, e.g.
!  * editor-style-rtl.css. If an array of stylesheets is passed to add_editor_style(),
   * RTL is only added for the first stylesheet.
   *
   * @since 3.0.0
   *
   * @param mixed $stylesheet Optional. Stylesheet name or array thereof, relative to theme root.
--- 1148,1161 ----
   * the theme root. It also accepts an array of stylesheets.
   * It is optional and defaults to 'editor-style.css'.
   *
!  * This function automatically adds another stylesheet with -rtl prefix, e.g. editor-style-rtl.css.
!  * If that file doesn't exist, it is removed before adding the stylesheet(s) to TinyMCE.
!  * If an array of stylesheets is passed to add_editor_style(),
   * RTL is only added for the first stylesheet.
   *
+  * Since version 3.4 the TinyMCE body has .rtl CSS class.
+  * It is a better option to use that class and add any RTL styles to the main stylesheet.
+  *
   * @since 3.0.0
   *
   * @param mixed $stylesheet Optional. Stylesheet name or array thereof, relative to theme root.
***************
*** 1863,1875 ****
  	global $_wp_theme_features;
  
  	if ( func_num_args() == 1 )
! 		$_wp_theme_features[$feature] = true;
  	else
! 		$_wp_theme_features[$feature] = array_slice( func_get_args(), 1 );
  
! 	if ( $feature == 'post-formats' && is_array( $_wp_theme_features[$feature][0] ) )
! 		$_wp_theme_features[$feature][0] = array_intersect( $_wp_theme_features[$feature][0], array_keys( get_post_format_slugs() ) );
  }
  
  /**
   * Gets the theme support arguments passed when registering that support
--- 1209,1380 ----
  	global $_wp_theme_features;
  
  	if ( func_num_args() == 1 )
! 		$args = true;
  	else
! 		$args = array_slice( func_get_args(), 1 );
! 
! 	switch ( $feature ) {
! 		case 'post-formats' :
! 			if ( is_array( $args[0] ) )
! 				$args[0] = array_intersect( $args[0], array_keys( get_post_format_slugs() ) );
! 			break;
! 
! 		case 'custom-header-uploads' :
! 			return add_theme_support( 'custom-header', array( 'uploads' => true ) );
! 			break;
! 
! 		case 'custom-header' :
! 			if ( ! is_array( $args ) )
! 				$args = array( 0 => array() );
! 
! 			$defaults = array(
! 				'default-image' => '',
! 				'random-default' => false,
! 				'width' => 0,
! 				'height' => 0,
! 				'flex-height' => false,
! 				'flex-width' => false,
! 				'default-text-color' => '',
! 				'header-text' => true,
! 				'uploads' => true,
! 				'wp-head-callback' => '',
! 				'admin-head-callback' => '',
! 				'admin-preview-callback' => '',
! 			);
! 
! 			$jit = isset( $args[0]['__jit'] );
! 			unset( $args[0]['__jit'] );
! 
! 			// Merge in data from previous add_theme_support() calls.
! 			// The first value registered wins. (A child theme is set up first.)
! 			if ( isset( $_wp_theme_features['custom-header'] ) )
! 				$args[0] = wp_parse_args( $_wp_theme_features['custom-header'][0], $args[0] );
! 
! 			// Load in the defaults at the end, as we need to insure first one wins.
! 			// This will cause all constants to be defined, as each arg will then be set to the default.
! 			if ( $jit )
! 				$args[0] = wp_parse_args( $args[0], $defaults );
! 
! 			// If a constant was defined, use that value. Otherwise, define the constant to ensure
! 			// the constant is always accurate (and is not defined later,  overriding our value).
! 			// As stated above, the first value wins.
! 			// Once we get to wp_loaded (just-in-time), define any constants we haven't already.
! 			// Constants are lame. Don't reference them. This is just for backwards compatibility.
! 
! 			if ( defined( 'NO_HEADER_TEXT' ) )
! 				$args[0]['header-text'] = ! NO_HEADER_TEXT;
! 			elseif ( isset( $args[0]['header-text'] ) )
! 				define( 'NO_HEADER_TEXT', empty( $args[0]['header-text'] ) );
! 
! 			if ( defined( 'HEADER_IMAGE_WIDTH' ) )
! 				$args[0]['width'] = (int) HEADER_IMAGE_WIDTH;
! 			elseif ( isset( $args[0]['width'] ) )
! 				define( 'HEADER_IMAGE_WIDTH', (int) $args[0]['width'] );
! 
! 			if ( defined( 'HEADER_IMAGE_HEIGHT' ) )
! 				$args[0]['height'] = (int) HEADER_IMAGE_HEIGHT;
! 			elseif ( isset( $args[0]['height'] ) )
! 				define( 'HEADER_IMAGE_HEIGHT', (int) $args[0]['height'] );
! 
! 			if ( defined( 'HEADER_TEXTCOLOR' ) )
! 				$args[0]['default-text-color'] = HEADER_TEXTCOLOR;
! 			elseif ( isset( $args[0]['default-text-color'] ) )
! 				define( 'HEADER_TEXTCOLOR', $args[0]['default-text-color'] );
! 
! 			if ( defined( 'HEADER_IMAGE' ) )
! 				$args[0]['default-image'] = HEADER_IMAGE;
! 			elseif ( isset( $args[0]['default-image'] ) )
! 				define( 'HEADER_IMAGE', $args[0]['default-image'] );
! 
! 			if ( $jit && ! empty( $args[0]['default-image'] ) )
! 				$args[0]['random-default'] = false;
! 
! 			// If headers are supported, and we still don't have a defined width or height,
! 			// we have implicit flex sizes.
! 			if ( $jit ) {
! 				if ( empty( $args[0]['width'] ) && empty( $args[0]['flex-width'] ) )
! 					$args[0]['flex-width'] = true;
! 				if ( empty( $args[0]['height'] ) && empty( $args[0]['flex-height'] ) )
! 					$args[0]['flex-height'] = true;
! 			}
! 
! 			break;
! 
! 		case 'custom-background' :
! 			if ( ! is_array( $args ) )
! 				$args = array( 0 => array() );
! 
! 			$defaults = array(
! 				'default-image' => '',
! 				'default-color' => '',
! 				'wp-head-callback' => '_custom_background_cb',
! 				'admin-head-callback' => '',
! 				'admin-preview-callback' => '',
! 			);
! 
! 			$jit = isset( $args[0]['__jit'] );
! 			unset( $args[0]['__jit'] );
! 
! 			// Merge in data from previous add_theme_support() calls. The first value registered wins.
! 			if ( isset( $_wp_theme_features['custom-background'] ) )
! 				$args[0] = wp_parse_args( $_wp_theme_features['custom-background'][0], $args[0] );
! 
! 			if ( $jit )
! 				$args[0] = wp_parse_args( $args[0], $defaults );
! 
! 			if ( defined( 'BACKGROUND_COLOR' ) )
! 				$args[0]['default-color'] = BACKGROUND_COLOR;
! 			elseif ( isset( $args[0]['default-color'] ) || $jit )
! 				define( 'BACKGROUND_COLOR', $args[0]['default-color'] );
! 
! 			if ( defined( 'BACKGROUND_IMAGE' ) )
! 				$args[0]['default-image'] = BACKGROUND_IMAGE;
! 			elseif ( isset( $args[0]['default-image'] ) || $jit )
! 				define( 'BACKGROUND_IMAGE', $args[0]['default-image'] );
! 
! 			break;
! 	}
! 
! 	$_wp_theme_features[ $feature ] = $args;
! }
! 
! /**
!  * Registers the internal custom header and background routines.
!  *
!  * @since 3.4.0
!  * @access private
!  */
! function _custom_header_background_just_in_time() {
! 	global $custom_image_header, $custom_background;
! 
! 	if ( current_theme_supports( 'custom-header' ) ) {
! 		// In case any constants were defined after an add_custom_image_header() call, re-run.
! 		add_theme_support( 'custom-header', array( '__jit' => true ) );
! 
! 		$args = get_theme_support( 'custom-header' );
! 		if ( $args[0]['wp-head-callback'] )
! 			add_action( 'wp_head', $args[0]['wp-head-callback'] );
! 
! 		if ( is_admin() ) {
! 			require_once( ABSPATH . 'wp-admin/custom-header.php' );
! 			$custom_image_header = new Custom_Image_Header( $args[0]['admin-head-callback'], $args[0]['admin-preview-callback'] );
! 		}
! 	}
  
! 	if ( current_theme_supports( 'custom-background' ) ) {
! 		// In case any constants were defined after an add_custom_background() call, re-run.
! 		add_theme_support( 'custom-background', array( '__jit' => true ) );
! 
! 		$args = get_theme_support( 'custom-background' );
! 		add_action( 'wp_head', $args[0]['wp-head-callback'] );
! 
! 		if ( is_admin() ) {
! 			require_once( ABSPATH . 'wp-admin/custom-background.php' );
! 			$custom_background = new Custom_Background( $args[0]['admin-head-callback'], $args[0]['admin-preview-callback'] );
! 		}
! 	}
  }
+ add_action( 'wp_loaded', '_custom_header_background_just_in_time' );
  
  /**
   * Gets the theme support arguments passed when registering that support
***************
*** 1880,1889 ****
   */
  function get_theme_support( $feature ) {
  	global $_wp_theme_features;
! 	if ( !isset( $_wp_theme_features[$feature] ) )
  		return false;
! 	else
! 		return $_wp_theme_features[$feature];
  }
  
  /**
--- 1385,1408 ----
   */
  function get_theme_support( $feature ) {
  	global $_wp_theme_features;
! 	if ( ! isset( $_wp_theme_features[ $feature ] ) )
  		return false;
! 
! 	if ( func_num_args() <= 1 )
! 		return $_wp_theme_features[ $feature ];
! 
! 	$args = array_slice( func_get_args(), 1 );
! 	switch ( $feature ) {
! 		case 'custom-header' :
! 		case 'custom-background' :
! 			if ( isset( $_wp_theme_features[ $feature ][0][ $args[0] ] ) )
! 				return $_wp_theme_features[ $feature ][0][ $args[0] ];
! 			return false;
! 			break;
! 		default :
! 			return $_wp_theme_features[ $feature ];
! 			break;
! 	}
  }
  
  /**
***************
*** 1899,1906 ****
   */
  function remove_theme_support( $feature ) {
  	// Blacklist: for internal registrations not used directly by themes.
! 	if ( in_array( $feature, array( 'custom-background', 'custom-header', 'editor-style', 'widgets', 'menus' ) ) )
  		return false;
  	return _remove_theme_support( $feature );
  }
  
--- 1418,1426 ----
   */
  function remove_theme_support( $feature ) {
  	// Blacklist: for internal registrations not used directly by themes.
! 	if ( in_array( $feature, array( 'editor-style', 'widgets', 'menus' ) ) )
  		return false;
+ 
  	return _remove_theme_support( $feature );
  }
  
***************
*** 1913,1921 ****
  function _remove_theme_support( $feature ) {
  	global $_wp_theme_features;
  
! 	if ( ! isset( $_wp_theme_features[$feature] ) )
  		return false;
! 	unset( $_wp_theme_features[$feature] );
  	return true;
  }
  
--- 1433,1467 ----
  function _remove_theme_support( $feature ) {
  	global $_wp_theme_features;
  
! 	switch ( $feature ) {
! 		case 'custom-header-uploads' :
! 			if ( ! isset( $_wp_theme_features['custom-header'] ) )
! 				return false;
! 			add_theme_support( 'custom-header', array( 'uploads' => false ) );
! 			return; // Do not continue - custom-header-uploads no longer exists.
! 	}
! 
! 	if ( ! isset( $_wp_theme_features[ $feature ] ) )
  		return false;
! 
! 	switch ( $feature ) {
! 		case 'custom-header' :
! 			$support = get_theme_support( 'custom-header' );
! 			if ( $support[0]['wp-head-callback'] )
! 				remove_action( 'wp_head', $support[0]['wp-head-callback'] );
! 			remove_action( 'admin_menu', array( $GLOBALS['custom_image_header'], 'init' ) );
! 			unset( $GLOBALS['custom_image_header'] );
! 			break;
! 
! 		case 'custom-background' :
! 			$support = get_theme_support( 'custom-background' );
! 			remove_action( 'wp_head', $support[0]['wp-head-callback'] );
! 			remove_action( 'admin_menu', array( $GLOBALS['custom_background'], 'init' ) );
! 			unset( $GLOBALS['custom_background'] );
! 			break;
! 	}
! 
! 	unset( $_wp_theme_features[ $feature ] );
  	return true;
  }
  
***************
*** 1929,1934 ****
--- 1475,1483 ----
  function current_theme_supports( $feature ) {
  	global $_wp_theme_features;
  
+ 	if ( 'custom-header-uploads' == $feature )
+ 		return current_theme_supports( 'custom-header', 'uploads' );
+ 
  	if ( !isset( $_wp_theme_features[$feature] ) )
  		return false;
  
***************
*** 1938,1948 ****
  
  	$args = array_slice( func_get_args(), 1 );
  
- 	// @todo Allow pluggable arg checking
  	switch ( $feature ) {
  		case 'post-thumbnails':
  			// post-thumbnails can be registered for only certain content/post types by passing
! 			// an array of types to add_theme_support().  If no array was passed, then
  			// any type is accepted
  			if ( true === $_wp_theme_features[$feature] )  // Registered for all types
  				return true;
--- 1487,1496 ----
  
  	$args = array_slice( func_get_args(), 1 );
  
  	switch ( $feature ) {
  		case 'post-thumbnails':
  			// post-thumbnails can be registered for only certain content/post types by passing
! 			// an array of types to add_theme_support(). If no array was passed, then
  			// any type is accepted
  			if ( true === $_wp_theme_features[$feature] )  // Registered for all types
  				return true;
***************
*** 1956,1964 ****
  			$post_format = $args[0];
  			return in_array( $post_format, $_wp_theme_features[$feature][0] );
  			break;
  	}
  
! 	return true;
  }
  
  /**
--- 1504,1520 ----
  			$post_format = $args[0];
  			return in_array( $post_format, $_wp_theme_features[$feature][0] );
  			break;
+ 
+ 		case 'custom-header':
+ 		case 'custom-background' :
+ 			// specific custom header and background capabilities can be registered by passing
+ 			// an array to add_theme_support()
+ 			$header_support = $args[0];
+ 			return ( isset( $_wp_theme_features[$feature][0][$header_support] ) && $_wp_theme_features[$feature][0][$header_support] );
+ 			break;
  	}
  
! 	return apply_filters('current_theme_supports-' . $feature, true, $args, $_wp_theme_features[$feature]);
  }
  
  /**
***************
*** 2000,2010 ****
  /**
   * Checks if a theme has been changed and runs 'after_switch_theme' hook on the next WP load
   *
!  * @since 3.3
   */
  function check_theme_switched() {
! 	if ( false !== ( $old_theme = get_option( 'theme_switched' ) ) && !empty( $old_theme ) ) {
! 		do_action( 'after_switch_theme', $old_theme );
  		update_option( 'theme_switched', false );
  	}
  }
--- 1556,1676 ----
  /**
   * Checks if a theme has been changed and runs 'after_switch_theme' hook on the next WP load
   *
!  * @since 3.3.0
   */
  function check_theme_switched() {
! 	if ( $stylesheet = get_option( 'theme_switched' ) ) {
! 		$old_theme = wp_get_theme( $stylesheet );
! 
! 		if ( $old_theme->exists() )
! 			do_action( 'after_switch_theme', $old_theme->get('Name'), $old_theme );
! 		else
! 			do_action( 'after_switch_theme', $stylesheet );
! 
  		update_option( 'theme_switched', false );
  	}
  }
+ 
+ /**
+  * Includes and instantiates the WP_Customize_Manager class.
+  *
+  * Fires when ?wp_customize=on or on wp-admin/customize.php.
+  *
+  * @since 3.4.0
+  */
+ function _wp_customize_include() {
+ 	if ( ! ( ( isset( $_REQUEST['wp_customize'] ) && 'on' == $_REQUEST['wp_customize'] )
+ 		|| ( is_admin() && 'customize.php' == basename( $_SERVER['PHP_SELF'] ) )
+ 	) )
+ 		return;
+ 
+ 	require( ABSPATH . WPINC . '/class-wp-customize-manager.php' );
+ 	// Init Customize class
+ 	$GLOBALS['wp_customize'] = new WP_Customize_Manager;
+ }
+ add_action( 'plugins_loaded', '_wp_customize_include' );
+ 
+ /**
+  * Adds settings for the customize-loader script.
+  *
+  * @since 3.4.0
+  */
+ function _wp_customize_loader_settings() {
+ 	global $wp_scripts;
+ 
+ 	$admin_origin = parse_url( admin_url() );
+ 	$home_origin  = parse_url( home_url() );
+ 	$cross_domain = ( strtolower( $admin_origin[ 'host' ] ) != strtolower( $home_origin[ 'host' ] ) );
+ 
+ 	$browser = array(
+ 		'mobile' => wp_is_mobile(),
+ 		'ios'    => wp_is_mobile() && preg_match( '/iPad|iPod|iPhone/', $_SERVER['HTTP_USER_AGENT'] ),
+ 	);
+ 
+ 	$settings = array(
+ 		'url'           => esc_url( admin_url( 'customize.php' ) ),
+ 		'isCrossDomain' => $cross_domain,
+ 		'browser'       => $browser,
+ 	);
+ 
+ 	$script = 'var _wpCustomizeLoaderSettings = ' . json_encode( $settings ) . ';';
+ 
+ 	$data = $wp_scripts->get_data( 'customize-loader', 'data' );
+ 	if ( $data )
+ 		$script = "$data\n$script";
+ 
+ 	$wp_scripts->add_data( 'customize-loader', 'data', $script );
+ }
+ add_action( 'admin_enqueue_scripts', '_wp_customize_loader_settings' );
+ 
+ /**
+  * Returns a URL to load the theme customizer.
+  *
+  * @since 3.4.0
+  *
+  * @param string $stylesheet Optional. Theme to customize. Defaults to current theme.
+  */
+ function wp_customize_url( $stylesheet = null ) {
+ 	$url = admin_url( 'customize.php' );
+ 	if ( $stylesheet )
+ 		$url .= '?theme=' . $stylesheet;
+ 	return esc_url( $url );
+ }
+ 
+ /**
+  * Prints a script to check whether or not the customizer is supported,
+  * and apply either the no-customize-support or customize-support class
+  * to the body.
+  *
+  * This function MUST be called inside the body tag.
+  *
+  * Ideally, call this function immediately after the body tag is opened.
+  * This prevents a flash of unstyled content.
+  *
+  * It is also recommended that you add the "no-customize-support" class
+  * to the body tag by default.
+  *
+  * @since 3.4.0
+  */
+ function wp_customize_support_script() {
+ 	$admin_origin = parse_url( admin_url() );
+ 	$home_origin  = parse_url( home_url() );
+ 	$cross_domain = ( strtolower( $admin_origin[ 'host' ] ) != strtolower( $home_origin[ 'host' ] ) );
+ 
+ 	?>
+ 	<script type="text/javascript">
+ 		(function() {
+ 			var request, b = document.body, c = 'className', cs = 'customize-support', rcs = new RegExp('(^|\\s+)(no-)?'+cs+'(\\s+|$)');
+ 
+ <?php		if ( $cross_domain ): ?>
+ 			request = (function(){ var xhr = new XMLHttpRequest(); return ('withCredentials' in xhr); })();
+ <?php		else: ?>
+ 			request = true;
+ <?php		endif; ?>
+ 
+ 			b[c] = b[c].replace( rcs, '' );
+ 			b[c] += ( window.postMessage && request ? ' ' : ' no-' ) + cs;
+ 		}());
+ 	</script>
+ 	<?php
+ }
\ No newline at end of file
